Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/And.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/And.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/And.cs	(revision 2202)
@@ -38,7 +38,5 @@
     public And()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs	(revision 2202)
@@ -34,5 +34,5 @@
     private const string OPERATORLIBRARY = "FunctionLibrary";
 
-    private GPOperatorLibrary operatorLibrary;
+    private FunctionLibrary operatorLibrary;
     private Variable variable;
 
@@ -44,5 +44,5 @@
       : base() {
       AddVariableInfo(new VariableInfo(TARGETVARIABLE, "The target variable", typeof(IntData), VariableKind.In));
-      AddVariableInfo(new VariableInfo(OPERATORLIBRARY, "Preconfigured default operator library", typeof(GPOperatorLibrary), VariableKind.New));
+      AddVariableInfo(new VariableInfo(OPERATORLIBRARY, "Preconfigured default operator library", typeof(FunctionLibrary), VariableKind.New));
     }
 
@@ -82,12 +82,12 @@
       //SetAllowedSubOperators(xor, allFunctions);
 
-      operatorLibrary = new GPOperatorLibrary();
-      operatorLibrary.GPOperatorGroup.AddOperator(and);
-      operatorLibrary.GPOperatorGroup.AddOperator(or);
+      operatorLibrary = new FunctionLibrary();
+      operatorLibrary.FunctionGroup.AddFunction(and);
+      operatorLibrary.FunctionGroup.AddFunction(or);
       //operatorLibrary.GPOperatorGroup.AddOperator(not);
-      operatorLibrary.GPOperatorGroup.AddOperator(nand);
-      operatorLibrary.GPOperatorGroup.AddOperator(nor);
+      operatorLibrary.FunctionGroup.AddFunction(nand);
+      operatorLibrary.FunctionGroup.AddFunction(nor);
       //operatorLibrary.GPOperatorGroup.AddOperator(xor);
-      operatorLibrary.GPOperatorGroup.AddOperator(variable);
+      operatorLibrary.FunctionGroup.AddFunction(variable);
     }
 
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Nand.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Nand.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Nand.cs	(revision 2202)
@@ -38,7 +38,5 @@
     public Nand()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Nor.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Nor.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Nor.cs	(revision 2202)
@@ -38,7 +38,5 @@
     public Nor()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Not.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Not.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Not.cs	(revision 2202)
@@ -38,6 +38,5 @@
     public Not()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(1, 1));
-      AddConstraint(new SubOperatorTypeConstraint(0));
+      MinArity = 1; MaxArity = 1;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Or.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Or.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Or.cs	(revision 2202)
@@ -38,7 +38,5 @@
     public Or()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Variable.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Variable.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Variable.cs	(revision 2202)
@@ -51,5 +51,5 @@
       GetVariableInfo(MANIPULATION).Local = false;
 
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
+      MinArity = 0; MaxArity = 0;
 
       ConstrainedIntData variable = new ConstrainedIntData();
@@ -75,10 +75,5 @@
       combinedOp.OperatorGraph.InitialOperator = seq;
       seq.AddSubOperator(indexRandomizer);
-      HeuristicLab.Core.IVariable initOp = GetVariable(INITIALIZATION);
-      if(initOp == null) {
-        AddVariable(new HeuristicLab.Core.Variable(INITIALIZATION, combinedOp));
-      } else {
-        initOp.Value = combinedOp;
-      }
+      Initializer = combinedOp;
     }
 
@@ -97,14 +92,9 @@
       combinedOp.OperatorGraph.InitialOperator = seq;
       seq.AddSubOperator(indexRandomizer);
-      HeuristicLab.Core.IVariable manipulationOp = GetVariable(MANIPULATION);
-      if(manipulationOp == null) {
-        AddVariable(new HeuristicLab.Core.Variable(MANIPULATION, combinedOp));
-      } else {
-        manipulationOp.Value = combinedOp;
-      }
+      Manipulator = combinedOp;
     }
 
     public void SetConstraints(int[] allowedIndexes) {
-      ConstrainedIntData index = GetVariableValue<ConstrainedIntData>(INDEX, null, false);
+      //ConstrainedIntData index = GetVariableValue<ConstrainedIntData>(INDEX, null, false);
       Array.Sort(allowedIndexes);
       minIndex = allowedIndexes[0]; maxIndex = allowedIndexes[allowedIndexes.Length - 1];
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Xor.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.Boolean/3.3/Xor.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.Boolean/3.3/Xor.cs	(revision 2202)
@@ -38,7 +38,5 @@
     public Xor()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/FunctionLibraryInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/FunctionLibraryInjector.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/FunctionLibraryInjector.cs	(revision 2202)
@@ -33,5 +33,5 @@
     private const string OPERATORLIBRARY = "FunctionLibrary";
 
-    private GPOperatorLibrary operatorLibrary;
+    private FunctionLibrary operatorLibrary;
 
     public override string Description {
@@ -41,5 +41,5 @@
     public FunctionLibraryInjector()
       : base() {
-      AddVariableInfo(new VariableInfo(OPERATORLIBRARY, "Preconfigured default operator library", typeof(GPOperatorLibrary), VariableKind.New));
+      AddVariableInfo(new VariableInfo(OPERATORLIBRARY, "Preconfigured default operator library", typeof(FunctionLibrary), VariableKind.New));
     }
 
@@ -71,11 +71,11 @@
       SetAllowedSubOperators(prog3, allFunctions);
 
-      operatorLibrary = new GPOperatorLibrary();
-      operatorLibrary.GPOperatorGroup.AddOperator(ifFoodAhead);
-      operatorLibrary.GPOperatorGroup.AddOperator(prog2);
-      operatorLibrary.GPOperatorGroup.AddOperator(prog3);
-      operatorLibrary.GPOperatorGroup.AddOperator(move);
-      operatorLibrary.GPOperatorGroup.AddOperator(left);
-      operatorLibrary.GPOperatorGroup.AddOperator(right);
+      operatorLibrary = new FunctionLibrary();
+      operatorLibrary.FunctionGroup.AddFunction(ifFoodAhead);
+      operatorLibrary.FunctionGroup.AddFunction(prog2);
+      operatorLibrary.FunctionGroup.AddFunction(prog3);
+      operatorLibrary.FunctionGroup.AddFunction(move);
+      operatorLibrary.FunctionGroup.AddFunction(left);
+      operatorLibrary.FunctionGroup.AddFunction(right);
     }
 
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/IfFoodAhead.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/IfFoodAhead.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/IfFoodAhead.cs	(revision 2202)
@@ -39,7 +39,5 @@
     public IfFoodAhead()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Left.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/Left.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Left.cs	(revision 2202)
@@ -39,5 +39,5 @@
     public Left()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
+      MinArity = 0; MaxArity = 0;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Move.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/Move.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Move.cs	(revision 2202)
@@ -39,5 +39,5 @@
     public Move()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
+      MinArity = 0; MaxArity = 0;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Prog2.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/Prog2.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Prog2.cs	(revision 2202)
@@ -39,7 +39,5 @@
     public Prog2()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
+      MinArity = 2; MaxArity = 2;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Prog3.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/Prog3.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Prog3.cs	(revision 2202)
@@ -39,8 +39,5 @@
     public Prog3()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(3, 3)); 
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-      AddConstraint(new SubOperatorTypeConstraint(2));
+      MinArity = 3; MaxArity = 3;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Right.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.SantaFe/3.3/Right.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.SantaFe/3.3/Right.cs	(revision 2202)
@@ -38,5 +38,5 @@
     public Right()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
+      MinArity = 0; MaxArity = 0;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Addition.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Addition.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Addition.cs	(revision 2202)
@@ -42,8 +42,6 @@
       : base() {
       // 2 - 3 seems like an reasonable defaut (used for +,-,*,/) (discussion with swinkler and maffenze)
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 3));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-      AddConstraint(new SubOperatorTypeConstraint(2));
+      MinArity = 2;
+      MaxArity = 3;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/And.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/And.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/And.cs	(revision 2202)
@@ -38,8 +38,5 @@
     public And()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 3));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-      AddConstraint(new SubOperatorTypeConstraint(2));
+      MinArity = 2; MaxArity = 3;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Average.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Average.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Average.cs	(revision 2202)
@@ -36,8 +36,5 @@
     public Average()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 3));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-      AddConstraint(new SubOperatorTypeConstraint(2));
+      MinArity = 2; MaxArity = 3;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BakedTreeEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/BakedTreeEvaluator.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BakedTreeEvaluator.cs	(revision 2202)
@@ -183,7 +183,4 @@
             return Math.Abs(x - y);
           }
-        case EvaluatorSymbolTable.UNKNOWN: { // evaluate functions which are not statically defined directly
-            return currInstr.function.Apply();
-          }
         default: {
             throw new NotImplementedException();
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/BinaryFunction.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/BinaryFunction.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/BinaryFunction.cs	(revision 2202)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Constraints;
+
+namespace HeuristicLab.GP.StructureIdentification {
+  public abstract class BinaryFunction : FunctionBase {
+    public BinaryFunction()
+      : base() {
+      MinArity = 2; MaxArity = 2;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/Terminal.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/Terminal.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/Terminal.cs	(revision 2202)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Constraints;
+
+namespace HeuristicLab.GP.StructureIdentification {
+  public abstract class Terminal : FunctionBase {
+    public Terminal()
+      : base() {
+      MinArity = 0; MaxArity = 0;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/UnaryFunction.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/UnaryFunction.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/BaseClasses/UnaryFunction.cs	(revision 2202)
@@ -0,0 +1,35 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Constraints;
+
+namespace HeuristicLab.GP.StructureIdentification {
+  public abstract class UnaryFunction : FunctionBase {
+    public UnaryFunction()
+      : base() {
+      MinArity = 1; MaxArity = 1;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Constant.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Constant.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Constant.cs	(revision 2202)
@@ -32,6 +32,7 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Constant : FunctionBase {
+  public sealed class Constant : Terminal {
     public const string VALUE = "Value";
+    private BakedFunctionTree constantNodeTemplate;
 
     public override string Description {
@@ -39,25 +40,26 @@
     }
 
+    public override IEnumerable<string> LocalParameterNames {
+      get {
+        return new string[] { VALUE };
+      }
+    }
+
     public Constant()
       : base() {
-      AddVariableInfo(new VariableInfo(VALUE, "The constant value", typeof(DoubleData), VariableKind.None));
-      GetVariableInfo(VALUE).Local = true;
-
       DoubleData valueData = new DoubleData();
-      // initialize a default range for the contant value
-      HeuristicLab.Core.Variable value = new HeuristicLab.Core.Variable(VALUE, valueData);
-      AddVariable(value);
+      constantNodeTemplate = new BakedFunctionTree(this);
+      constantNodeTemplate.AddVariable(new HeuristicLab.Core.Variable(VALUE, valueData));
 
       SetupInitialization();
       SetupManipulation();
+    }
 
-      // constant can't have suboperators
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
+    public override IFunctionTree GetTreeNode() {
+      return (IFunctionTree)constantNodeTemplate.Clone();
     }
 
     private void SetupInitialization() {
       // initialization operator
-      AddVariableInfo(new VariableInfo(INITIALIZATION, "Initialization operator-graph for constants", typeof(IOperatorGraph), VariableKind.None));
-      GetVariableInfo(INITIALIZATION).Local = false;
       CombinedOperator combinedOp = new CombinedOperator();
       SequentialProcessor initSeq = new SequentialProcessor();
@@ -70,11 +72,9 @@
       combinedOp.OperatorGraph.InitialOperator = initSeq;
       initSeq.AddSubOperator(randomizer);
-      AddVariable(new HeuristicLab.Core.Variable(INITIALIZATION, combinedOp));
+      Initializer = combinedOp;
     }
 
     private void SetupManipulation() {
       // manipulation operator
-      AddVariableInfo(new VariableInfo(MANIPULATION, "Manipulation operator-graph for constants", typeof(IOperatorGraph), VariableKind.None));
-      GetVariableInfo(MANIPULATION).Local = false;
       CombinedOperator combinedOp = new CombinedOperator();
       SequentialProcessor manipulationSeq = new SequentialProcessor();
@@ -87,5 +87,5 @@
       combinedOp.OperatorGraph.InitialOperator = manipulationSeq;
       manipulationSeq.AddSubOperator(valueAdder);
-      AddVariable(new HeuristicLab.Core.Variable(MANIPULATION, combinedOp));
+      Manipulator = combinedOp;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Cosinus.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Cosinus.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Cosinus.cs	(revision 2202)
@@ -29,5 +29,5 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Cosinus : FunctionBase {
+  public sealed class Cosinus : UnaryFunction {
     public override string Description {
       get { return "Returns the cosinus of the first sub-tree."; }
@@ -36,7 +36,4 @@
     public Cosinus()
       : base() {
-      // must have exactly one subfunction
-      AddConstraint(new NumberOfSubOperatorsConstraint(1, 1));
-      AddConstraint(new SubOperatorTypeConstraint(0));
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Differential.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Differential.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Differential.cs	(revision 2202)
@@ -40,7 +40,5 @@
     }
 
-    public Differential()
-      : base() {
-    }
+    public Differential() : base() { }
   }
 }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Division.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Division.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Division.cs	(revision 2202)
@@ -30,7 +30,5 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Division : FunctionBase {
-    private const double EPSILON = 10.0E-20; // if any divisor is < EPSILON return 0
-
+  public sealed class Division : BinaryFunction {
     public override string Description {
       get {
@@ -46,12 +44,5 @@
     }
 
-    public Division()
-      : base() {
-      // 2 - 3 seems like an reasonable defaut (used for +,-,*,/) (discussion with swinkler and maffenze)
-      //MK changed to only 2 allowed suboperators to be compliant with HL2
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-    }
+    public Division() : base() { }
   }
 }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Equal.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Equal.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Equal.cs	(revision 2202)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Equal : FunctionBase {
+  public sealed class Equal : BinaryFunction {
     public override string Description {
       get {
@@ -35,10 +35,5 @@
     }
 
-    public Equal()
-      : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
-    }
+    public Equal() : base() { }
   }
 }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Exponential.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Exponential.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Exponential.cs	(revision 2202)
@@ -29,15 +29,10 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Exponential : FunctionBase {
+  public sealed class Exponential : UnaryFunction {
     public override string Description {
       get { return "Returns returns exponential of the first sub-tree (power(e, x))."; }
     }
 
-    public Exponential()
-      : base() {
-      // must have exactly one sub-operator
-      AddConstraint(new NumberOfSubOperatorsConstraint(1, 1));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-    }
+    public Exponential() : base() { }
   }
 }
